<TeXmacs|1.0.7.20>

<style|beamer>

<\body>
  <screens|<\shown>
    <\with|par-mode|center>
      <space|0cm|0cm|2.5fn><strong|<with|font-base-size|17|Vers un
      compilateur pour Mathemagix>>
    </with>

    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|1|2|2|cell-valign|c>|<table|<row|<cell|
      >|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|<img|<image|texmacs-chip.ps|0.5w|0.5h||>>>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|>|<cell|>>|<row|<cell|>|<cell|Gecko
      2007>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.mathemagix.org>>|<cell|>>|<row|<cell|>|<cell|<verbatim|http://www.<TeXmacs*>.org>>|<cell|>>>>>
    </with>

    \;
  </shown>|<\hidden>
    <tit|Motivations et objectifs>

    <\folded>
      Langage de programmation orient vers les mathmatiques
    <|folded>
      <\itemize-minus>
        <item>Langage fonctionnel fortement typ avec gnricit.

        <item>Manipulation simple et intgre d'objets symboliques.

        <item>Possibilit de compilation <math|\<rightsquigarrow\>> bonnes
        performances.
      </itemize-minus>
    </folded>

    <\folded>
      Historique
    <|folded>
      <\itemize-minus>
        <item>Lisp, Maxima.

        <item>Axiom, Aldor.

        <\folded-plain>
          <item>Mathemagix.
        <|folded-plain>
          <\enumerate>
            <item>Compilateur sur le modle d'Aldor.

            <item>Interprteur, mmx-shell, systme de types avec surcharge.

            <item>Interprteur abstrait, mmx-light, type symbolique.

            <item>Compilateur.
          </enumerate>
        </folded-plain>
      </itemize-minus>
    </folded>
  </hidden>|<\hidden>
    <tit|Langages existants>

    \;

    \;

    <htab|5mm><ornament|<anim-translate|<tabular|<tformat|<cwith|1|-1|1|1|cell-rborder|0.5ln>|<cwith|1|-1|2|2|cell-rborder|0.5ln>|<cwith|1|-1|3|3|cell-rborder|0.5ln>|<cwith|1|-1|4|4|cell-rborder|0.5ln>|<cwith|1|1|1|-1|cell-bborder|0.5ln>|<cwith|8|8|1|-1|cell-bborder|0.5ln>|<cwith|2|2|1|-1|cell-bborder|0.5ln>|<cwith|3|3|1|-1|cell-bborder|0.5ln>|<cwith|4|4|1|-1|cell-bborder|0.5ln>|<cwith|5|5|1|-1|cell-bborder|0.5ln>|<cwith|6|6|1|-1|cell-bborder|0.5ln>|<cwith|9|9|1|-1|cell-bborder|>|<cwith|7|7|1|-1|cell-bborder|0.5ln>|<table|<row|<cell|>|<cell|C++>|<cell|Aldor>|<cell|Lisp>|<cell|Ocaml>|<cell|>>|<row|<cell|Surcharge>|<cell|<with|color|dark
    green|oui>>|<cell|<with|color|dark green|oui>>|<cell|<with|color|dark
    green|clos>>|<cell|<with|color|red|non>>|<cell|>>|<row|<cell|Conversions
    implicites>|<cell|<with|color|brown|ouais>>|<cell|<with|color|red|non>>|<cell|<with|color|red|non>>|<cell|<with|color|red|non>>|<cell|>>|<row|<cell|Templates
    (modles)>|<cell|<with|color|brown|ouais>>|<cell|<with|color|red|non>>|<cell|<with|color|brown|macro>>|<cell|<with|color|dark
    green|oui>>|<cell|>>|<row|<cell|Gnricit>|<cell|<with|color|red|non>>|<cell|<with|color|dark
    green|oui>>|<cell|<with|color|red|non>>|<cell|<with|color|brown|ouais>>|<cell|>>|<row|<cell|Types
    symboliques>|<cell|<with|color|red|non>>|<cell|<with|color|red|non>>|<cell|<with|color|dark
    green|oui>>|<cell|<with|color|dark green|oui>>|<cell|>>|<row|<cell|Fonctionnel>|<cell|<with|color|red|non>>|<cell|<with|color|dark
    green|oui>>|<cell|<with|color|dark green|oui>>|<cell|<with|color|dark
    green|oui>>|<cell|>>|<row|<cell|Efficacit>|<cell|<with|color|dark
    green|oui>>|<cell|<with|color|brown|ouais>>|<cell|<with|color|brown|ouais>>|<cell|<with|color|brown|ouais>>|<cell|>>|<row|<cell|Standard>|<cell|<with|color|dark
    green|oui>>|<cell|<with|color|red|non>>|<cell|<with|color|dark
    green|oui>>|<cell|<with|color|red|non>>|<cell|>>>>>|2sec|<tuple|0.0|-1.0>|>><htab|5mm>

    \;

    \;

    \;
  </hidden>|<\hidden>
    <tit|Principe d'incertitude smantique>

    <\folded>
      Langages sans surcharge : Ocaml, etc.
    <|folded>
      \;

      <\equation*>
        f(x)\<equiv\>x+1
      </equation*>

      \;

      Typage automatique <math|f:Int\<longrightarrow\>Int>

      \;

      <\equation*>
        f(x)\<equiv\>x+<rsub|Float>1.0
      </equation*>

      \;
    </folded>

    <\folded>
      Langages avec surcharge : C++, Aldor, Mathemagix, etc.
    <|folded>
      \;

      <\equation*>
        <tabular*|<tformat|<cwith|1|-1|3|3|cell-halign|l>|<table|<row|<cell|+>|<cell|:>|<cell|Int,Int\<longrightarrow\>Int>>|<row|<cell|+>|<cell|:>|<cell|Float,Float\<longrightarrow\>Float>>>>>
      </equation*>

      Dclarations types :

      \;

      <\equation*>
        f(x:Int):Int\<equiv\>x+1
      </equation*>
    </folded>
  </hidden>|<\hidden>
    <tit|Conversions implicites>

    <\folded>
      Transitivit
    <|folded>
      <\description>
        <item*|Caster>Pas de transitivit.

        <item*|Upgrader> droite : <math|A\<longrightarrowlim\><rsup|up>B,B\<longrightarrow\>C\<Rightarrow\>A\<longrightarrow\>C>
        <with|color|brown|constructeur>

        <item*|Downgrader> gauche : <math|A\<longrightarrow\>B,B\<longrightarrowlim\><rsup|down>C\<Rightarrow\>A\<longrightarrow\>C>
        <with|color|brown|hritage>

        <item*|Converter>Les deux.
      </description>
    </folded>

    <\folded>
      Priorit
    <|folded>
      <\description>
        <item*|Inclusions><math|Integer\<longrightarrow\>Rational>

        <item*|Homomorphismes><math|Integer\<longrightarrow\>Modular_integer(p)>

        <item*|Caster><math|Integer\<longrightarrow\>Float>

        <item*|Abstraction><math|Integer\<longrightarrow\>Generic>

        <math|\<forall\>T,T\<longrightarrow\>Generic> \ et
        \ <math|\<forall\>T,T\<longrightarrow\>Vector(T)>
      </description>
    </folded>

    <\folded>
      Dcidabilit
    <|folded>
      \;

      <math|A<rsub|1>\<longrightarrow\>\<cdots\>\<longrightarrow\>A<rsub|n>\<longrightarrow\>B<rsub|n>\<longrightarrow\>\<cdots\>\<longrightarrow\>B<rsub|0>>
    </folded>
  </hidden>|<\hidden>
    <tit|Templates et gnricit>

    <\fold-back>
      <\folded>
        Templates sans vrification<nbsp>: C++, etc.
      <|folded>
        <\code>
          template\<less\>typename C\<gtr\> vector\<less\>C\<gtr\>

          operator + (const vector\<less\>C\<gtr\>& v, const
          vector\<less\>C\<gtr\>& w) {

          \ \ int i, n= min (dimension (v), dimension (w));

          \ \ vector\<less\>C\<gtr\> r (n)

          \ \ for (i=0; i\<less\>n; i++) r[i]= v[i] + w[i];

          \ \ return r;

          }
        </code>
      </folded>

      <\folded>
        Catgories<nbsp>: Aldor, etc.
      <|folded>
        <\code>
          Ring: Category == with {

          \ \ +: (%, %) -\<gtr\> %;

          \ \ ...

          }

          \;

          Vector (R: Ring): Ring == add {

          \ \ (x: %) + (y: %): % == {

          \ \ \ \ import R;

          \ \ \ \ ...

          \ \ }

          \ \ ...

          }
        </code>

        <\folded>
          Desavantages
        <|folded>
          <\itemize-minus>
            <item>Importation implicite disagrable.

            <item>Demande structuration au pralable en catgories.

            <item>Routines doivent tre attaches  des catgories.
          </itemize-minus>
        </folded>

        \;
      </folded>

      <\folded>
        \S Paradigme Mathemagix \T : dclarations sous hypothses
      <|folded>
        <\code>
          Ring: Category == category {

          \ \ +: (%, %) -\<gtr\> %;

          \ \ ...

          }

          \;

          forall (R: Ring)

          infix + (v: Vector R, w: Vector R): Vector R == {

          \ \ ...

          }
        </code>
      </folded>
    </fold-back>
  </hidden>|<\hidden>
    <tit|Diffrences dans l'implantation>

    <\folded>
      Templates C++
    <|folded>
      <\itemize-minus>
        <item>Macros. Exemple<nbsp>: <verbatim|complexify\<less\>C\<gtr\>>
        <math|\<rightarrow\>> <verbatim|complexify\<less\>double\<gtr\>>.

        <item>Problme<nbsp>: <verbatim|modular\<less\>p\<gtr\>> quand
        <verbatim|p> est variable.

        <item>Solution : variable globale avec <verbatim|p>, mais
        multi-threading...

        <item>Problme<nbsp>: <verbatim|polynomial\<less\>C\<gtr\>> avec
        <verbatim|C> variable.
      </itemize-minus>
    </folded>

    <\folded>
      Gnricit
    <|folded>
      <\itemize-minus>
        <item>Passage de paramtre<nbsp>:
        <verbatim|<with|font-shape|proportional|mpz_mul (limb* d, limb* a,
        limb* b, int i, int j);>>

        <item>Ou encore : <verbatim|ring_el* square (ring_el* x, ring R);>

        <item>Problme : passage du paramtre admet un cot.
      </itemize-minus>
    </folded>

    <\folded>
      Unification
    <|folded>
      <\itemize-minus>
        <item>Mme code dans les deux cas.

        <item>Exemple<nbsp>: <math|\<forall\>R:Ring,\<forall\>i:\<bbb-N\>,\<forall\>j:\<bbb-N\>,\<forall\>k:\<bbb-N\>,Mat(R,i,j)\<times\>Mat(R,j,k)\<rightarrow\>Mat(R,i,k)>.

        <item>Utilisation gnrique <with|color|red|et> spcialisation pour
        <math|Mat(Double,2,2)>.
      </itemize-minus>
    </folded>
  </hidden>|<\hidden>
    <tit|Spcialisations>

    <\folded>
      Prfrence des types les plus spcialiss
    <|folded>
      <\code>
        forall (T: Type) f (x: T): Void == ...;

        f (x: Rational): Void == ...;

        f (x: Integer): Void == ...;

        \;

        f(3);
      </code>
    </folded>

    <\folded>
      Priorits
    <|folded>
      <\code>
        (v: Vector T) [i: Integer]: T == ...;

        (v: Alias Vector T) [i: Integer]: Alias T == ...;

        \;

        v: Vector T := ...;

        mmout \<less\>\<less\> v[3] \<less\>\<less\> "\\n";

        v[4] := x;
      </code>

      Note : priorits <math|\<leftrightsquigarrow\>> relation d'ordre
      abstrait <math|\<leftrightsquigarrow\>> conversions implicites
      atomiques
    </folded>
  </hidden>|<\hidden>
    <tit|Typer les ambiguts>

    <\folded>
      <with|color|brown|Surcharge <math|\<wedge\>>>
    <|folded>
      <math|+:(Int,Int)\<longrightarrow\>Int<space|1.2spc>\<wedge\><space|1.2spc>(Float,Float)\<longrightarrow\>Float><vspace|0.5fn>
    </folded>

    <\folded>
      <with|color|brown|Unions <math|\<vee\>>>
    <|folded>
      <math|Failable(T)\<equiv\>T\<vee\>{false}><vspace|0.5fn>
    </folded>

    <\folded>
      <with|color|brown|Modles <math|\<forall\>>>
    <|folded>
      <math|print:\<forall\>T,(Printer,T)\<longrightarrow\>Void><vspace|0.5fn>
    </folded>

    <\folded>
      <with|color|brown|Gnricit <math|\<exists\>>>
    <|folded>
      <math|Generic\<equiv\>\<exists\>T,T><vspace|0.5fn>
    </folded>

    <\folded>
      <with|color|brown|Types conditionnels <math|\<Rightarrow\>>>
    <|folded>
      <math|\<times\>:\<forall\>T,T:Ring\<Rightarrow\>(Vector T,Vector
      T)\<rightarrow\>Vector T><vspace|0.5fn>
    </folded>

    <\folded>
      <with|color|brown|Conversions implicites, hypothses>
    <|folded>
      <math|\<forall\>T,T\<longrightarrow\>Vector T>
    </folded>
  </hidden>|<\hidden>
    <tit|Expressions symboliques>

    <\folded>
      Compatibilit entre <math|Generic> et l'environnement
    <|folded>
      <\code>
        x: Generic == 2;

        f (x: Integer): Integer == ...;

        f(x);
      </code>
    </folded>

    <\folded>
      Dispatching automatique
    <|folded>
      <\code>
        (x: dispatch Generic) + (y: dispatch Generic): Generic;

        (x: Integer) + (y: Integer): Integer;

        (x: Rational) + (y: Rational): Rational;
      </code>

      Problmes de scope ?

      \;
    </folded>

    <\folded>
      Downgrade automatique
    <|folded>
      <\code>
        2 * ((3 :\<gtr\> Generic) / 2)
      </code>

      Spcialisation

      <\code>
        cast: Rational -\<gtr\> Generic
      </code>
    </folded>
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|info-flag|none>
    <associate|language|french>
    <associate|page-bot|5mm>
    <associate|page-even|5mm>
    <associate|page-odd|5mm>
    <associate|page-right|5mm>
    <associate|page-screen-bot|5mm>
    <associate|page-screen-top|5mm>
    <associate|page-show-hf|true>
    <associate|page-top|5mm>
    <associate|preamble|false>
    <associate|sfactor|4>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|auto-1|<tuple|1|?>>
    <associate|auto-10|<tuple|10|?>>
    <associate|auto-11|<tuple|11|?>>
    <associate|auto-12|<tuple|12|?>>
    <associate|auto-13|<tuple|13|?>>
    <associate|auto-2|<tuple|2|?>>
    <associate|auto-3|<tuple|3|?>>
    <associate|auto-4|<tuple|4|?>>
    <associate|auto-5|<tuple|5|?>>
    <associate|auto-6|<tuple|6|?>>
    <associate|auto-7|<tuple|7|?>>
    <associate|auto-8|<tuple|8|?>>
    <associate|auto-9|<tuple|9|?>>
    <associate|cross-rel|<tuple|1|?>>
    <associate|eq-fonc|<tuple|1|15>>
    <associate|mv-th|<tuple|<with|mode|<quote|math>|\<bullet\>>|?>>
    <associate|toc-1|<tuple|<uninit>|2>>
    <associate|toc-10|<tuple|2|5>>
    <associate|toc-11|<tuple|2|5>>
    <associate|toc-12|<tuple|2|5>>
    <associate|toc-13|<tuple|2|5>>
    <associate|toc-14|<tuple|2|6>>
    <associate|toc-15|<tuple|2|6>>
    <associate|toc-16|<tuple|2|6>>
    <associate|toc-17|<tuple|2|7>>
    <associate|toc-18|<tuple|2|7>>
    <associate|toc-19|<tuple|2|7>>
    <associate|toc-2|<tuple|<uninit>|3>>
    <associate|toc-20|<tuple|2|7>>
    <associate|toc-21|<tuple|2|8>>
    <associate|toc-22|<tuple|2|8>>
    <associate|toc-23|<tuple|2|8>>
    <associate|toc-24|<tuple|2|8>>
    <associate|toc-25|<tuple|2|8>>
    <associate|toc-26|<tuple|2|8>>
    <associate|toc-27|<tuple|2|9>>
    <associate|toc-28|<tuple|2|9>>
    <associate|toc-29|<tuple|2|9>>
    <associate|toc-3|<tuple|<uninit>|3>>
    <associate|toc-30|<tuple|2|10>>
    <associate|toc-31|<tuple|2|10>>
    <associate|toc-32|<tuple|2|10>>
    <associate|toc-33|<tuple|2|11>>
    <associate|toc-34|<tuple|2|12>>
    <associate|toc-35|<tuple|2|13>>
    <associate|toc-36|<tuple|2|14>>
    <associate|toc-37|<tuple|2|14>>
    <associate|toc-38|<tuple|2|14>>
    <associate|toc-39|<tuple|2|15>>
    <associate|toc-4|<tuple|<uninit>|3>>
    <associate|toc-40|<tuple|2|15>>
    <associate|toc-41|<tuple|2|15>>
    <associate|toc-42|<tuple|2|15>>
    <associate|toc-43|<tuple|2|16>>
    <associate|toc-44|<tuple|2|16>>
    <associate|toc-45|<tuple|2|16>>
    <associate|toc-46|<tuple|2|17>>
    <associate|toc-47|<tuple|2|17>>
    <associate|toc-48|<tuple|2|17>>
    <associate|toc-49|<tuple|2|17>>
    <associate|toc-5|<tuple|<uninit>|3>>
    <associate|toc-50|<tuple|2|?>>
    <associate|toc-6|<tuple|<uninit>|4>>
    <associate|toc-7|<tuple|<uninit>|4>>
    <associate|toc-8|<tuple|2|4>>
    <associate|toc-9|<tuple|2|4>>
  </collection>
</references>